if importPath==nil then importPath=string.gsub(getfenv(1)._.Name,"%.Options","").."." end
if resourcePath==nil then resourcePath=string.gsub(importPath,"%.","/").."Resources/" end

if Turbine==nil then
	import "Turbine"
end
if Turbine.UI==nil then
	import "Turbine.UI"
end
if Turbine.UI.Lotro==nil then
	import "Turbine.UI.Lotro"
end

OptionsWindow=Turbine.UI.Lotro.Window()
local optionsWidth=700
local optionsHeight=300
if settings.optionsLeft==nil then
	settings.optionsLeft=((displayWidth-optionsWidth)/2)/displayWidth
else
	settings.optionsLeft=euroNormalize(settings.optionsLeft)
end
if settings.optionsTop==nil then
	settings.optionsTop=((displayHeight-optionsHeight)/2)/displayHeight
else
	settings.optionsTop=euroNormalize(settings.optionsTop)
end
OptionsWindow:SetSize(optionsWidth,optionsHeight)
OptionsWindow:SetPosition(displayWidth*settings.optionsLeft,displayHeight*settings.optionsTop)
OptionsWindow:SetText(Resource[language][3])

local labelWidth=200
OptionsWindow.loginTxtCap=Turbine.UI.Label()
OptionsWindow.loginTxtCap:SetParent(OptionsWindow)
OptionsWindow.loginTxtCap:SetPosition(6,45)
OptionsWindow.loginTxtCap:SetSize(labelWidth,22)
OptionsWindow.loginTxtCap:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
OptionsWindow.loginTxtCap:SetFont(Turbine.UI.Lotro.Font.Verdana20)
OptionsWindow.loginTxtCap:SetText(Resource[language][8]..":")
OptionsWindow.loginTxt=Turbine.UI.Lotro.TextBox()
OptionsWindow.loginTxt:SetParent(OptionsWindow)
OptionsWindow.loginTxt:SetSize(OptionsWindow:GetWidth()-14-labelWidth,22)
OptionsWindow.loginTxt:SetPosition(OptionsWindow.loginTxtCap:GetLeft()+OptionsWindow.loginTxtCap:GetWidth()+2,OptionsWindow.loginTxtCap:GetTop())
OptionsWindow.loginTxt:SetFont(Turbine.UI.Lotro.Font.Verdana20)
OptionsWindow.loginTxt:SetText(settings.loginMsg)

OptionsWindow.loginSkillCap=Turbine.UI.Label()
OptionsWindow.loginSkillCap:SetParent(OptionsWindow)
OptionsWindow.loginSkillCap:SetPosition(6,OptionsWindow.loginTxtCap:GetTop()+OptionsWindow.loginTxtCap:GetHeight()+5)
OptionsWindow.loginSkillCap:SetSize(labelWidth,34)
OptionsWindow.loginSkillCap:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
OptionsWindow.loginSkillCap:SetFont(Turbine.UI.Lotro.Font.Verdana20)
OptionsWindow.loginSkillCap:SetText(Resource[language][9]..":")
OptionsWindow.loginSkill=Turbine.UI.Lotro.Quickslot()
OptionsWindow.loginSkill:SetParent(OptionsWindow)
OptionsWindow.loginSkill:SetSize(34,34)
OptionsWindow.loginSkill:SetPosition(OptionsWindow.loginSkillCap:GetLeft()+OptionsWindow.loginSkillCap:GetWidth()+2,OptionsWindow.loginSkillCap:GetTop())
setSkillTxt=function(skillType,skillData)
	local skillTxt
	if skillType~=nil and skillType~=nil then
		for k,v in pairs(Turbine.UI.Lotro.ShortcutType) do
			if skillType==v then
				skillTxt=k
				break
			end
		end
		OptionsWindow.loginSkillTxt:SetText(skillTxt.." "..skillData)
	end
end
OptionsWindow.loginSkill.DragDrop=function(sender,args)
--	Table.Dump(args.DragDropInfo)
-- how to prevent swapping of item that is dropped?
--	args.DragDropInfo:SetSuccessful(false) -- doesn't seem to affect the dragdrop op
	-- get the shortcut settings
	local sc=args.DragDropInfo:GetShortcut()
	OptionsWindow.loginSkillType=sc:GetType()
	OptionsWindow.loginSkillData=sc:GetData()
	setSkillTxt(OptionsWindow.loginSkillType,OptionsWindow.loginSkillData)
	return
end
OptionsWindow.loginSkillDelete=Turbine.UI.Control()
OptionsWindow.loginSkillDelete:SetParent(OptionsWindow)
OptionsWindow.loginSkillDelete:SetSize(16,16)
OptionsWindow.loginSkillDelete:SetPosition(OptionsWindow.loginSkill:GetLeft()+OptionsWindow.loginSkill:GetWidth()+1,OptionsWindow.loginSkill:GetTop()+9)
OptionsWindow.loginSkillDelete:SetBackground(resourcePath.."Delete.tga")
OptionsWindow.loginSkillDelete.MouseClick=function()
	-- clear the skill
	OptionsWindow.loginSkill:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, "" ))
	OptionsWindow.loginSkillType=nil
	OptionsWindow.loginSkillData=nil
	OptionsWindow.loginSkillTxt:SetText("")
end

OptionsWindow.loginSkillTxt=Turbine.UI.Label()
OptionsWindow.loginSkillTxt:SetParent(OptionsWindow)
OptionsWindow.loginSkillTxt:SetPosition(OptionsWindow.loginSkillDelete:GetLeft()+17,OptionsWindow.loginSkillCap:GetTop())
OptionsWindow.loginSkillTxt:SetSize(OptionsWindow:GetWidth()-OptionsWindow.loginSkillTxt:GetLeft()-6,34)
OptionsWindow.loginSkillTxt:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
OptionsWindow.loginSkillTxt:SetFont(Turbine.UI.Lotro.Font.Verdana20)
if settings.loginSkill~=nil and settings.loginSkillType~=nil then
	local sc=Turbine.UI.Lotro.Shortcut(settings.loginSkillType,"");
	sc:SetData(settings.loginSkill);
	OptionsWindow.loginSkill:SetShortcut(sc);
	setSkillTxt(settings.loginSkillType,settings.loginSkill)
end

OptionsWindow.logoutTxtCap=Turbine.UI.Label()
OptionsWindow.logoutTxtCap:SetParent(OptionsWindow)
OptionsWindow.logoutTxtCap:SetPosition(6,OptionsWindow.loginSkillCap:GetTop()+OptionsWindow.loginSkillCap:GetHeight()+5)
OptionsWindow.logoutTxtCap:SetSize(labelWidth,22)
OptionsWindow.logoutTxtCap:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
OptionsWindow.logoutTxtCap:SetFont(Turbine.UI.Lotro.Font.Verdana20)
OptionsWindow.logoutTxtCap:SetText(Resource[language][10]..":")
OptionsWindow.logoutTxt=Turbine.UI.Lotro.TextBox()
OptionsWindow.logoutTxt:SetParent(OptionsWindow)
OptionsWindow.logoutTxt:SetSize(OptionsWindow:GetWidth()-14-labelWidth,22)
OptionsWindow.logoutTxt:SetPosition(OptionsWindow.logoutTxtCap:GetLeft()+OptionsWindow.logoutTxtCap:GetWidth()+2,OptionsWindow.logoutTxtCap:GetTop())
OptionsWindow.logoutTxt:SetFont(Turbine.UI.Lotro.Font.Verdana20)
OptionsWindow.logoutTxt:SetText(settings.logoutMsg)

-- color
OptionsWindow.txtColorCap=Turbine.UI.Label()
OptionsWindow.txtColorCap:SetParent(OptionsWindow)
OptionsWindow.txtColorCap:SetPosition(6,OptionsWindow.logoutTxtCap:GetTop()+OptionsWindow.logoutTxtCap:GetHeight()+5)
OptionsWindow.txtColorCap:SetSize(labelWidth,22)
OptionsWindow.txtColorCap:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
OptionsWindow.txtColorCap:SetFont(Turbine.UI.Lotro.Font.Verdana20)
OptionsWindow.txtColorCap:SetText(Resource[language][11]..":")
OptionsWindow.txtColor=ColorPicker()
OptionsWindow.txtColor:SetParent(OptionsWindow);
OptionsWindow.txtColor:SetPosition(OptionsWindow.txtColorCap:GetLeft()+OptionsWindow.txtColorCap:GetWidth()+5,OptionsWindow.txtColorCap:GetTop()-1);
OptionsWindow.txtColor:SetTrimColor(Turbine.UI.Color.Grey);
getColorFromCode=function(code)
	local color=tonumber(code)
	local color2=math.floor(color/256)
	local b=(color-color2*256)/255
	local color3=math.floor(color2/256)
	local g=(color2-color3*256)/255
	local r=color3/255
	return Turbine.UI.Color(1,r,g,b)
end
getCodeFromColor=function(color)
	return string.format("0x%x",(color.R*255*256+color.G*255)*256+color.B*255)
end
OptionsWindow.txtColor:SetColor(getColorFromCode(settings.color))
OptionsWindow.txtColor.ColorChanged=function()
	OptionsWindow.colorLabel:SetText(getCodeFromColor(OptionsWindow.txtColor:GetColor()))
end
OptionsWindow.colorLabel=Turbine.UI.Label()
OptionsWindow.colorLabel:SetParent(OptionsWindow)
OptionsWindow.colorLabel:SetPosition(OptionsWindow.txtColor:GetLeft()+OptionsWindow.txtColor:GetWidth()+5,OptionsWindow.txtColor:GetTop())
OptionsWindow.colorLabel:SetSize(OptionsWindow:GetWidth()-OptionsWindow.colorLabel:GetLeft()-6,22)
OptionsWindow.colorLabel:SetFont(Turbine.UI.Lotro.Font.Verdana20)
OptionsWindow.colorLabel:SetText(settings.color)

-- font
OptionsWindow.txtFontCap=Turbine.UI.Label()
OptionsWindow.txtFontCap:SetParent(OptionsWindow)
OptionsWindow.txtFontCap:SetPosition(6,OptionsWindow.txtColorCap:GetTop()+OptionsWindow.txtColorCap:GetHeight()+5)
OptionsWindow.txtFontCap:SetSize(labelWidth,22)
OptionsWindow.txtFontCap:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
OptionsWindow.txtFontCap:SetFont(Turbine.UI.Lotro.Font.Verdana20)
OptionsWindow.txtFontCap:SetText(Resource[language][12]..":")
OptionsWindow.fontIcon=Turbine.UI.Control()
OptionsWindow.fontIcon:SetParent(OptionsWindow)
OptionsWindow.fontIcon:SetSize(23,20)
OptionsWindow.fontIcon:SetPosition(OptionsWindow.txtFontCap:GetLeft()+OptionsWindow.txtFontCap:GetWidth()+2,OptionsWindow.txtFontCap:GetTop())
OptionsWindow.fontIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay)
OptionsWindow.fontIcon:SetBackground(resourcePath.."TextIcon.jpg")
OptionsWindow.fontIcon.MouseClick=function()
	OptionsWindow.fontSelect:MouseClick()
end
OptionsWindow.fontLabel=Turbine.UI.Label()
OptionsWindow.fontLabel:SetParent(OptionsWindow)
OptionsWindow.fontLabel:SetPosition(OptionsWindow.fontIcon:GetLeft()+28,OptionsWindow.txtFontCap:GetTop())
OptionsWindow.fontLabel:SetSize(OptionsWindow:GetWidth()-OptionsWindow.fontLabel:GetLeft()-11,22)
OptionsWindow.fontLabel:SetFont(Turbine.UI.Lotro.Font.Verdana20)
OptionsWindow.fontLabel.MouseClick=function()
	OptionsWindow.fontSelect:MouseClick()
end
OptionsWindow.fontSelect=FontSelect()
OptionsWindow.fontSelect:SetParent(OptionsWindow)
OptionsWindow.fontSelect:SetSize(0,0)
OptionsWindow.fontSelect:SetPosition(OptionsWindow.txtFontCap:GetLeft()+OptionsWindow.txtFontCap:GetWidth()+22,OptionsWindow.txtFontCap:GetTop())
OptionsWindow.fontSelect.FontChanged=function()
	local font=OptionsWindow.fontSelect:GetFont()
	OptionsWindow.fontLabel:SetText(Turbine.UI.Lotro.FontInfo[font].name.." "..Turbine.UI.Lotro.FontInfo[font].size.."pt")
	OptionsWindow.newFont=font
end
OptionsWindow.fontLabel:SetText(Turbine.UI.Lotro.FontInfo[settings.font].name.." "..Turbine.UI.Lotro.FontInfo[settings.font].size.."pt")
OptionsWindow.newFont=settings.font

-- useChar
OptionsWindow.useCharCap=Turbine.UI.Label()
OptionsWindow.useCharCap:SetParent(OptionsWindow)
OptionsWindow.useCharCap:SetPosition(6,OptionsWindow.txtFontCap:GetTop()+OptionsWindow.txtFontCap:GetHeight()+5)
OptionsWindow.useCharCap:SetSize(labelWidth,22)
OptionsWindow.useCharCap:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
OptionsWindow.useCharCap:SetFont(Turbine.UI.Lotro.Font.Verdana20)
OptionsWindow.useCharCap:SetText(Resource[language][13]..":")
OptionsWindow.useCharCB=Turbine.UI.Lotro.CheckBox()
OptionsWindow.useCharCB:SetParent(OptionsWindow)
OptionsWindow.useCharCB:SetSize(16,16)
OptionsWindow.useCharCB:SetPosition(OptionsWindow.useCharCap:GetLeft()+OptionsWindow.useCharCap:GetWidth()+2,OptionsWindow.useCharCap:GetTop()+5)
--OptionsWindow.useCharCB:SetFont(Turbine.UI.Lotro.Font.Verdana20)
--OptionsWindow.useCharCB:SetText(settings.logoutMsg)
OptionsWindow.useCharCB:SetChecked(settings.useChar)
OptionsWindow.useCharCB.CheckChanged=function()
end

-- defeatShow
OptionsWindow.defeatShowCap=Turbine.UI.Label()
OptionsWindow.defeatShowCap:SetParent(OptionsWindow)
OptionsWindow.defeatShowCap:SetPosition(6,OptionsWindow.useCharCap:GetTop()+OptionsWindow.useCharCap:GetHeight()+5)
OptionsWindow.defeatShowCap:SetSize(labelWidth,22)
OptionsWindow.defeatShowCap:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
OptionsWindow.defeatShowCap:SetFont(Turbine.UI.Lotro.Font.Verdana20)
OptionsWindow.defeatShowCap:SetText(Resource[language][14]..":")
OptionsWindow.defeatShowCB=Turbine.UI.Lotro.CheckBox()
OptionsWindow.defeatShowCB:SetParent(OptionsWindow)
OptionsWindow.defeatShowCB:SetSize(16,16)
OptionsWindow.defeatShowCB:SetPosition(OptionsWindow.defeatShowCap:GetLeft()+OptionsWindow.defeatShowCap:GetWidth()+2,OptionsWindow.defeatShowCap:GetTop()+5)
--OptionsWindow.defeatShowCB:SetFont(Turbine.UI.Lotro.Font.Verdana20)
--OptionsWindow.defeatShowCB:SetText(settings.logoutMsg)
OptionsWindow.defeatShowCB:SetChecked(settings.defeatShow)
OptionsWindow.defeatShowCB.CheckChanged=function()
end

OptionsWindow.OK=Turbine.UI.Lotro.Button()
OptionsWindow.OK:SetParent(OptionsWindow)
OptionsWindow.OK:SetSize(100,20)
OptionsWindow.OK:SetPosition((OptionsWindow:GetWidth()-OptionsWindow.OK:GetWidth()*2)/3,OptionsWindow:GetHeight()-45)
OptionsWindow.OK:SetText(Resource[language][5])
OptionsWindow.OK.Click=function()
	-- need to set color and font first since they get used when setting msg
	settings.color=getCodeFromColor(OptionsWindow.txtColor:GetColor())
	settings.font=OptionsWindow.newFont
	settings.loginMsg=string.trim(OptionsWindow.loginTxt:GetText())
	setMessage(lrMain.msgIn,settings.loginMsg)
	settings.loginSkillType=OptionsWindow.loginSkillType
	settings.loginSkill=OptionsWindow.loginSkillData
	if settings.loginSkill~=nil and settings.loginSkillType~=nil then
		local sc=Turbine.UI.Lotro.Shortcut(settings.loginSkillType,"");
		sc:SetData(settings.loginSkill);
		lrMain.skillQS:SetShortcut(sc);
	else
		-- make sure they are BOTH nil and the clear the quickslot
		settings.loginSkill=nil
		settings.loginSkill=nil
		lrMain.skillQS:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, "" ))
	end
	settings.logoutMsg=string.trim(OptionsWindow.logoutTxt:GetText())
	setMessage(lrMain.msgOut,settings.logoutMsg)
	settings.useChar=OptionsWindow.useCharCB:IsChecked()
	settings.defeatShow=OptionsWindow.defeatShowCB:IsChecked()
	OptionsWindow:SetVisible(false)
end

OptionsWindow.Cancel=Turbine.UI.Lotro.Button()
OptionsWindow.Cancel:SetParent(OptionsWindow)
OptionsWindow.Cancel:SetSize(OptionsWindow.OK:GetWidth(),20)
OptionsWindow.Cancel:SetPosition(OptionsWindow.OK:GetLeft()+OptionsWindow.OK:GetWidth()+(OptionsWindow:GetWidth()-200)/3,OptionsWindow:GetHeight()-45)
OptionsWindow.Cancel:SetText(Resource[language][6])
OptionsWindow.Cancel.Click=function()
	OptionsWindow.loginTxt:SetText(settings.loginMsg)
	OptionsWindow.loginSkillType=settings.loginSkillType
	OptionsWindow.loginSkillData=settings.loginSkill
	if settings.loginSkill~=nil and settings.loginSkillType~=nil then
		local sc=Turbine.UI.Lotro.Shortcut(settings.loginSkillType,"");
		sc:SetData(settings.loginSkill);
		OptionsWindow.loginSkill:SetShortcut(sc);
		setSkillTxt(settings.loginSkillType,settings.loginSkill)
	else
		OptionsWindow.loginSkill:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, "" ))
	end
	OptionsWindow.logoutTxt:SetText(settings.logoutMsg)
	OptionsWindow:SetVisible(false)
end
OptionsWindow.KeyDown=function(sender, args)
	if bShowKeyDown==true then
		Turbine.Shell.WriteLine("KeyDown Action="..args.Action..", .Alt="..tostring(args.Alt)..", .Control="..tostring(args.Control)..", .Shift="..tostring(args.Shift))
	end
	if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
		setupWindow:SetVisible( false );
		inventoryWindow:SetVisible(false);
		minimalWindow:SetVisible(false);
		iconWindow:SetVisible(Settings.showIcon);
	end
end
OptionsWindow.Closed=function()
	OptionsWindow:SetWantsKeyEvents(false)
end